(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/common/http'), require('@angular/core'), require('@yukawa/chain-base-angular-client')) :
    typeof define === 'function' && define.amd ? define('@yukawa/chain-main-angular-core', ['exports', '@angular/common/http', '@angular/core', '@yukawa/chain-base-angular-client'], factory) :
    (global = global || self, factory((global.yukawa = global.yukawa || {}, global.yukawa['chain-main-angular-core'] = {}), global.ng.common.http, global.ng.core, global.chainBaseAngularClient));
}(this, (function (exports, http, core, chainBaseAngularClient) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __createBinding(o, m, k, k2) {
        if (k2 === undefined) k2 = k;
        o[k2] = m[k];
    }

    function __exportStar(m, exports) {
        for (var p in m) if (p !== "default" && !exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m) return m.call(o);
        if (o && typeof o.length === "number") return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }

    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * \@generator rest2ts
     * 	javaType: inc.yukawa.chain.modules.main.core.domain.group.Group <br/>
     * @record
     */
    function Group() { }
    if (false) {
        /** @type {?|undefined} */
        Group.prototype.change;
        /** @type {?|undefined} */
        Group.prototype.created;
        /** @type {?|undefined} */
        Group.prototype.info;
        /**
         * \@example users
         * @type {?}
         */
        Group.prototype.name;
        /**
         * \@example all
         * @type {?|undefined}
         */
        Group.prototype.parentId;
        /** @type {?} */
        Group.prototype.roles;
        /**
         * \@example system
         * @type {?|undefined}
         */
        Group.prototype.type;
    }
    /**
     * \@generator rest2ts
     * 	javaType: inc.yukawa.chain.modules.main.core.domain.group.GroupFilter <br/>
     * @record
     */
    function GroupFilter() { }
    if (false) {
        /**
         * \@example ADMINS
         * @type {?|undefined}
         */
        GroupFilter.prototype.groupName;
        /**
         * \@example system
         * @type {?|undefined}
         */
        GroupFilter.prototype.type;
    }
    /**
     * \@generator rest2ts
     * 	javaType: inc.yukawa.chain.modules.main.core.domain.org.Org <br/>
     * @record
     */
    function Org() { }
    if (false) {
        /** @type {?|undefined} */
        Org.prototype.addresses;
        /** @type {?|undefined} */
        Org.prototype.change;
        /**
         * \@example Yukawa Systems GmbH
         * @type {?|undefined}
         */
        Org.prototype.companyName;
        /** @type {?|undefined} */
        Org.prototype.created;
        /**
         * \@example yukawa\@example.com
         * @type {?|undefined}
         */
        Org.prototype.email;
        /** @type {?|undefined} */
        Org.prototype.info;
        /**
         * \@example 100
         * @type {?|undefined}
         */
        Org.prototype.orgId;
        /**
         * \@example +49 100 200 300
         * @type {?|undefined}
         */
        Org.prototype.phoneNumber;
        /**
         * \@example DE113344
         * @type {?|undefined}
         */
        Org.prototype.taxId;
        /**
         * \@example http://yukawa.de/
         * @type {?|undefined}
         */
        Org.prototype.website;
    }
    /**
     * \@generator rest2ts
     * 	javaType: inc.yukawa.chain.modules.main.core.domain.org.OrgFilter <br/>
     * @record
     */
    function OrgFilter() { }
    if (false) {
        /** @type {?|undefined} */
        OrgFilter.prototype.addressFilter;
        /** @type {?|undefined} */
        OrgFilter.prototype.companyName;
        /** @type {?|undefined} */
        OrgFilter.prototype.email;
        /**
         * \@example 100
         * @type {?|undefined}
         */
        OrgFilter.prototype.orgId;
        /** @type {?|undefined} */
        OrgFilter.prototype.phoneNumber;
        /**
         * \@example DE113344
         * @type {?|undefined}
         */
        OrgFilter.prototype.taxId;
        /** @type {?|undefined} */
        OrgFilter.prototype.website;
    }
    /**
     * \@generator rest2ts
     * 	javaType: inc.yukawa.chain.modules.main.core.domain.setting.Setting <br/>
     * @record
     */
    function Setting() { }
    if (false) {
        /** @type {?|undefined} */
        Setting.prototype.change;
        /**
         * \@example default central storage location
         * @type {?|undefined}
         */
        Setting.prototype.desc;
        /**
         * \@example main
         * @type {?}
         */
        Setting.prototype.module;
        /**
         * \@example Central Storage Location
         * @type {?|undefined}
         */
        Setting.prototype.name;
        /**
         * \@example storage.location.central
         * @type {?}
         */
        Setting.prototype.shortName;
        /**
         * \@example 1337
         * @type {?}
         */
        Setting.prototype.value;
    }
    /**
     * \@generator rest2ts
     * 	javaType: inc.yukawa.chain.modules.main.core.domain.setting.SettingFilter <br/>
     * @record
     */
    function SettingFilter() { }
    if (false) {
        /**
         * \@example stock
         * @type {?|undefined}
         */
        SettingFilter.prototype.module;
        /**
         * \@example storage*
         * @type {?|undefined}
         */
        SettingFilter.prototype.shortName;
    }
    /**
     * \@generator rest2ts
     * 	javaType: inc.yukawa.chain.modules.main.core.domain.tag.Tag <br/>
     * @record
     */
    function Tag() { }
    if (false) {
        /** @type {?|undefined} */
        Tag.prototype.change;
        /** @type {?} */
        Tag.prototype.info;
        /** @type {?|undefined} */
        Tag.prototype.key;
        /** @type {?|undefined} */
        Tag.prototype.tagId;
        /** @type {?|undefined} */
        Tag.prototype.vocabularyId;
    }
    /**
     * \@generator rest2ts
     * 	javaType: inc.yukawa.chain.modules.main.core.domain.tag.TagFilter <br/>
     * @record
     */
    function TagFilter() { }
    /**
     * \@generator rest2ts
     * 	javaType: inc.yukawa.chain.modules.main.core.domain.user.User <br/>
     * @record
     */
    function User() { }
    if (false) {
        /** @type {?} */
        User.prototype.account;
        /** @type {?|undefined} */
        User.prototype.change;
        /** @type {?|undefined} */
        User.prototype.created;
        /** @type {?|undefined} */
        User.prototype.groups;
        /** @type {?|undefined} */
        User.prototype.organisationIds;
        /** @type {?|undefined} */
        User.prototype.person;
        /**
         * \@example admin
         * @type {?}
         */
        User.prototype.username;
    }
    /**
     * \@generator rest2ts
     * 	javaType: inc.yukawa.chain.modules.main.core.domain.user.UserFilter <br/>
     * @record
     */
    function UserFilter() { }
    if (false) {
        /**
         * \@example admins
         * @type {?|undefined}
         */
        UserFilter.prototype.group;
        /** @type {?|undefined} */
        UserFilter.prototype.organisationIds;
        /** @type {?|undefined} */
        UserFilter.prototype.personFilter;
        /**
         * \@example admin
         * @type {?|undefined}
         */
        UserFilter.prototype.username;
    }
    /**
     * \@generator rest2ts
     * 	tag vocabulary <br/>
     * 	javaType: inc.yukawa.chain.modules.main.core.domain.tag.Vocabulary <br/>
     * @record
     */
    function Vocabulary() { }
    if (false) {
        /** @type {?|undefined} */
        Vocabulary.prototype.key;
        /** @type {?|undefined} */
        Vocabulary.prototype.vocabularyId;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * \@generator rest2ts
     * 	javaType: inc.yukawa.chain.modules.main.rest.GroupsAspectRest <br/>
     */
    var GroupsService = /** @class */ (function () {
        function GroupsService(httpService, configService) {
            this.httpService = httpService;
            this.configService = configService;
        }
        /**
         * @param {?} groupName
         * @return {?}
         */
        GroupsService.prototype.deleteGroup = /**
         * @param {?} groupName
         * @return {?}
         */
        function (groupName) {
            return this.httpService.delete('groups/' + groupName + '');
        };
        /**
         * @param {?} group
         * @return {?}
         */
        GroupsService.prototype.editGroup = /**
         * @param {?} group
         * @return {?}
         */
        function (group) {
            /** @type {?} */
            var headers = new http.HttpHeaders().set('Content-type', 'application/json');
            return this.httpService.put('groups', group, { headers: headers });
        };
        /**
         * @param {?=} pageSize
         * @param {?=} firstResult
         * @return {?}
         */
        GroupsService.prototype.findGroups = /**
         * @param {?=} pageSize
         * @param {?=} firstResult
         * @return {?}
         */
        function (pageSize, firstResult) {
            var e_1, _a;
            /** @type {?} */
            var queryParamsList = [];
            if (pageSize !== undefined && pageSize !== null) {
                queryParamsList.push({ name: 'pageSize', value: pageSize.toString() });
            }
            if (firstResult !== undefined && firstResult !== null) {
                queryParamsList.push({ name: 'firstResult', value: firstResult.toString() });
            }
            /** @type {?} */
            var params = new http.HttpParams();
            try {
                for (var queryParamsList_1 = __values(queryParamsList), queryParamsList_1_1 = queryParamsList_1.next(); !queryParamsList_1_1.done; queryParamsList_1_1 = queryParamsList_1.next()) {
                    var queryParam = queryParamsList_1_1.value;
                    params = params.append(queryParam.name, queryParam.value);
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (queryParamsList_1_1 && !queryParamsList_1_1.done && (_a = queryParamsList_1.return)) _a.call(queryParamsList_1);
                }
                finally { if (e_1) throw e_1.error; }
            }
            return this.httpService.get('groups/find', { params: params });
        };
        /**
         * @param {?} group
         * @return {?}
         */
        GroupsService.prototype.insertGroup = /**
         * @param {?} group
         * @return {?}
         */
        function (group) {
            /** @type {?} */
            var headers = new http.HttpHeaders().set('Content-type', 'application/json');
            return this.httpService.post('groups', group, { headers: headers });
        };
        /**
         * @param {?} groupName
         * @return {?}
         */
        GroupsService.prototype.loadGroup = /**
         * @param {?} groupName
         * @return {?}
         */
        function (groupName) {
            return this.httpService.get('groups/' + groupName + '');
        };
        /**
         * @param {?} arg0
         * @return {?}
         */
        GroupsService.prototype.queryGroups = /**
         * @param {?} arg0
         * @return {?}
         */
        function (arg0) {
            /** @type {?} */
            var headers = new http.HttpHeaders().set('Content-type', 'application/json');
            return this.httpService.post('groups/query', arg0, { headers: headers });
        };
        GroupsService.decorators = [
            { type: core.Injectable }
        ];
        /** @nocollapse */
        GroupsService.ctorParameters = function () { return [
            { type: http.HttpClient },
            { type: chainBaseAngularClient.ConfigService }
        ]; };
        return GroupsService;
    }());
    if (false) {
        /** @type {?} */
        GroupsService.prototype.configService;
        /** @type {?} */
        GroupsService.prototype.httpService;
    }
    /**
     * \@generator rest2ts
     * 	javaType: inc.yukawa.chain.modules.main.rest.MainModuleRest <br/>
     */
    var MainModuleRest = /** @class */ (function () {
        function MainModuleRest(httpService, configService) {
            this.httpService = httpService;
            this.configService = configService;
        }
        MainModuleRest.decorators = [
            { type: core.Injectable }
        ];
        /** @nocollapse */
        MainModuleRest.ctorParameters = function () { return [
            { type: http.HttpClient },
            { type: chainBaseAngularClient.ConfigService }
        ]; };
        return MainModuleRest;
    }());
    if (false) {
        /** @type {?} */
        MainModuleRest.prototype.configService;
        /** @type {?} */
        MainModuleRest.prototype.httpService;
    }
    /**
     * \@generator rest2ts
     * 	javaType: inc.yukawa.chain.modules.main.rest.OrgAspectRestBase <br/>
     * @template V, F
     */
    var OrgServiceBase = /** @class */ (function () {
        function OrgServiceBase(httpService, configService) {
            this.httpService = httpService;
            this.configService = configService;
        }
        /**
         * @param {?} arg0
         * @return {?}
         */
        OrgServiceBase.prototype.createOrg = /**
         * @param {?} arg0
         * @return {?}
         */
        function (arg0) {
            /** @type {?} */
            var headers = new http.HttpHeaders().set('Content-type', 'application/json');
            return this.httpService.post('orgs', arg0, { headers: headers });
        };
        /**
         * @param {?} orgId
         * @return {?}
         */
        OrgServiceBase.prototype.deleteOrg = /**
         * @param {?} orgId
         * @return {?}
         */
        function (orgId) {
            return this.httpService.delete('orgs/' + orgId + '');
        };
        /**
         * @param {?} orgId
         * @return {?}
         */
        OrgServiceBase.prototype.loadOrg = /**
         * @param {?} orgId
         * @return {?}
         */
        function (orgId) {
            return this.httpService.get('orgs/' + orgId + '');
        };
        /**
         * @param {?} filter
         * @return {?}
         */
        OrgServiceBase.prototype.queryOrgs = /**
         * @param {?} filter
         * @return {?}
         */
        function (filter) {
            /** @type {?} */
            var headers = new http.HttpHeaders().set('Content-type', 'application/json');
            return this.httpService.post('orgs/query', filter, { headers: headers });
        };
        /**
         * @param {?} arg0
         * @return {?}
         */
        OrgServiceBase.prototype.updateOrg = /**
         * @param {?} arg0
         * @return {?}
         */
        function (arg0) {
            /** @type {?} */
            var headers = new http.HttpHeaders().set('Content-type', 'application/json');
            return this.httpService.put('orgs', arg0, { headers: headers });
        };
        OrgServiceBase.decorators = [
            { type: core.Injectable }
        ];
        /** @nocollapse */
        OrgServiceBase.ctorParameters = function () { return [
            { type: http.HttpClient },
            { type: chainBaseAngularClient.ConfigService }
        ]; };
        return OrgServiceBase;
    }());
    if (false) {
        /** @type {?} */
        OrgServiceBase.prototype.configService;
        /** @type {?} */
        OrgServiceBase.prototype.httpService;
    }
    /**
     * \@generator rest2ts
     * 	javaType: inc.yukawa.chain.modules.main.rest.RolesAspectRest <br/>
     */
    var RolesService = /** @class */ (function () {
        function RolesService(httpService, configService) {
            this.httpService = httpService;
            this.configService = configService;
        }
        /**
         * @param {?} filter
         * @return {?}
         */
        RolesService.prototype.findRoles = /**
         * @param {?} filter
         * @return {?}
         */
        function (filter) {
            /** @type {?} */
            var headers = new http.HttpHeaders().set('Content-type', 'application/json');
            return this.httpService.post('/roles/find', filter, { headers: headers });
        };
        /**
         * @return {?}
         */
        RolesService.prototype.getAllRoles = /**
         * @return {?}
         */
        function () {
            return this.httpService.get('/roles/all');
        };
        /**
         * @param {?} roleName
         * @return {?}
         */
        RolesService.prototype.loadRole = /**
         * @param {?} roleName
         * @return {?}
         */
        function (roleName) {
            return this.httpService.get('/roles/' + roleName + '');
        };
        /**
         * @param {?} filter
         * @return {?}
         */
        RolesService.prototype.queryRoles = /**
         * @param {?} filter
         * @return {?}
         */
        function (filter) {
            /** @type {?} */
            var headers = new http.HttpHeaders().set('Content-type', 'application/json');
            return this.httpService.post('/roles/query', filter, { headers: headers });
        };
        RolesService.decorators = [
            { type: core.Injectable }
        ];
        /** @nocollapse */
        RolesService.ctorParameters = function () { return [
            { type: http.HttpClient },
            { type: chainBaseAngularClient.ConfigService }
        ]; };
        return RolesService;
    }());
    if (false) {
        /** @type {?} */
        RolesService.prototype.configService;
        /** @type {?} */
        RolesService.prototype.httpService;
    }
    /**
     * \@generator rest2ts
     * 	javaType: inc.yukawa.chain.modules.main.rest.SettingsAspectRest <br/>
     */
    var SettingsService = /** @class */ (function () {
        function SettingsService(httpService, configService) {
            this.httpService = httpService;
            this.configService = configService;
        }
        /**
         * @param {?} module
         * @param {?} shortName
         * @return {?}
         */
        SettingsService.prototype.deleteSetting = /**
         * @param {?} module
         * @param {?} shortName
         * @return {?}
         */
        function (module, shortName) {
            return this.httpService.delete('settings/' + module + '/' + shortName + '');
        };
        /**
         * @param {?} setting
         * @return {?}
         */
        SettingsService.prototype.editSetting = /**
         * @param {?} setting
         * @return {?}
         */
        function (setting) {
            /** @type {?} */
            var headers = new http.HttpHeaders().set('Content-type', 'application/json');
            return this.httpService.put('settings', setting, { headers: headers });
        };
        /**
        *	find settings
        */
        /**
         * 	find settings
         * @param {?=} module
         * @param {?=} shortName
         * @param {?=} keyword
         * @param {?=} pageSize
         * @param {?=} firstResult
         * @return {?}
         */
        SettingsService.prototype.findSettings = /**
         * 	find settings
         * @param {?=} module
         * @param {?=} shortName
         * @param {?=} keyword
         * @param {?=} pageSize
         * @param {?=} firstResult
         * @return {?}
         */
        function (module, shortName, keyword, pageSize, firstResult) {
            var e_2, _a;
            /** @type {?} */
            var queryParamsList = [];
            if (module !== undefined && module !== null) {
                queryParamsList.push({ name: 'module', value: module });
            }
            if (shortName !== undefined && shortName !== null) {
                queryParamsList.push({ name: 'shortName', value: shortName });
            }
            if (keyword !== undefined && keyword !== null) {
                queryParamsList.push({ name: 'keyword', value: keyword });
            }
            if (pageSize !== undefined && pageSize !== null) {
                queryParamsList.push({ name: 'pageSize', value: pageSize.toString() });
            }
            if (firstResult !== undefined && firstResult !== null) {
                queryParamsList.push({ name: 'firstResult', value: firstResult.toString() });
            }
            /** @type {?} */
            var params = new http.HttpParams();
            try {
                for (var queryParamsList_2 = __values(queryParamsList), queryParamsList_2_1 = queryParamsList_2.next(); !queryParamsList_2_1.done; queryParamsList_2_1 = queryParamsList_2.next()) {
                    var queryParam = queryParamsList_2_1.value;
                    params = params.append(queryParam.name, queryParam.value);
                }
            }
            catch (e_2_1) { e_2 = { error: e_2_1 }; }
            finally {
                try {
                    if (queryParamsList_2_1 && !queryParamsList_2_1.done && (_a = queryParamsList_2.return)) _a.call(queryParamsList_2);
                }
                finally { if (e_2) throw e_2.error; }
            }
            return this.httpService.get('settings', { params: params });
        };
        /**
         * @return {?}
         */
        SettingsService.prototype.getMeta = /**
         * @return {?}
         */
        function () {
            return this.httpService.get('settings/admin/meta');
        };
        /**
         * @return {?}
         */
        SettingsService.prototype.loadMapping = /**
         * @return {?}
         */
        function () {
            return this.httpService.get('settings/admin/index');
        };
        /**
         * @param {?} module
         * @param {?} shortName
         * @return {?}
         */
        SettingsService.prototype.loadSetting = /**
         * @param {?} module
         * @param {?} shortName
         * @return {?}
         */
        function (module, shortName) {
            return this.httpService.get('settings/' + module + '/' + shortName + '');
        };
        /**
         * @param {?=} input
         * @return {?}
         */
        SettingsService.prototype.ping = /**
         * @param {?=} input
         * @return {?}
         */
        function (input) {
            var e_3, _a;
            /** @type {?} */
            var queryParamsList = [];
            if (input !== undefined && input !== null) {
                queryParamsList.push({ name: 'input', value: input.toString() });
            }
            /** @type {?} */
            var params = new http.HttpParams();
            try {
                for (var queryParamsList_3 = __values(queryParamsList), queryParamsList_3_1 = queryParamsList_3.next(); !queryParamsList_3_1.done; queryParamsList_3_1 = queryParamsList_3.next()) {
                    var queryParam = queryParamsList_3_1.value;
                    params = params.append(queryParam.name, queryParam.value);
                }
            }
            catch (e_3_1) { e_3 = { error: e_3_1 }; }
            finally {
                try {
                    if (queryParamsList_3_1 && !queryParamsList_3_1.done && (_a = queryParamsList_3.return)) _a.call(queryParamsList_3);
                }
                finally { if (e_3) throw e_3.error; }
            }
            return this.httpService.get('settings/ping', { params: params });
        };
        /**
         * @param {?} filter
         * @return {?}
         */
        SettingsService.prototype.querySettings = /**
         * @param {?} filter
         * @return {?}
         */
        function (filter) {
            /** @type {?} */
            var headers = new http.HttpHeaders().set('Content-type', 'application/json');
            return this.httpService.post('settings/query', filter, { headers: headers });
        };
        SettingsService.decorators = [
            { type: core.Injectable }
        ];
        /** @nocollapse */
        SettingsService.ctorParameters = function () { return [
            { type: http.HttpClient },
            { type: chainBaseAngularClient.ConfigService }
        ]; };
        return SettingsService;
    }());
    if (false) {
        /** @type {?} */
        SettingsService.prototype.configService;
        /** @type {?} */
        SettingsService.prototype.httpService;
    }
    /**
     * \@generator rest2ts
     * 	javaType: inc.yukawa.chain.modules.main.rest.TagAspectRest <br/>
     */
    var TagService = /** @class */ (function () {
        function TagService(httpService, configService) {
            this.httpService = httpService;
            this.configService = configService;
        }
        /**
         * @param {?=} arg0
         * @return {?}
         */
        TagService.prototype.ping = /**
         * @param {?=} arg0
         * @return {?}
         */
        function (arg0) {
            var e_4, _a;
            /** @type {?} */
            var queryParamsList = [];
            if (arg0 !== undefined && arg0 !== null) {
                queryParamsList.push({ name: 'arg0', value: arg0.toString() });
            }
            /** @type {?} */
            var params = new http.HttpParams();
            try {
                for (var queryParamsList_4 = __values(queryParamsList), queryParamsList_4_1 = queryParamsList_4.next(); !queryParamsList_4_1.done; queryParamsList_4_1 = queryParamsList_4.next()) {
                    var queryParam = queryParamsList_4_1.value;
                    params = params.append(queryParam.name, queryParam.value);
                }
            }
            catch (e_4_1) { e_4 = { error: e_4_1 }; }
            finally {
                try {
                    if (queryParamsList_4_1 && !queryParamsList_4_1.done && (_a = queryParamsList_4.return)) _a.call(queryParamsList_4);
                }
                finally { if (e_4) throw e_4.error; }
            }
            return this.httpService.get('tags/ping', { params: params });
        };
        /**
         * @param {?} arg0
         * @return {?}
         */
        TagService.prototype.queryTags = /**
         * @param {?} arg0
         * @return {?}
         */
        function (arg0) {
            /** @type {?} */
            var headers = new http.HttpHeaders().set('Content-type', 'application/json');
            return this.httpService.post('tags/query', arg0, { headers: headers });
        };
        TagService.decorators = [
            { type: core.Injectable }
        ];
        /** @nocollapse */
        TagService.ctorParameters = function () { return [
            { type: http.HttpClient },
            { type: chainBaseAngularClient.ConfigService }
        ]; };
        return TagService;
    }());
    if (false) {
        /** @type {?} */
        TagService.prototype.configService;
        /** @type {?} */
        TagService.prototype.httpService;
    }
    /**
     * \@generator rest2ts
     * 	javaType: inc.yukawa.chain.modules.main.rest.UserAspectRestBase <br/>
     * @template V, F
     */
    var UserServiceBase = /** @class */ (function () {
        function UserServiceBase(httpService, configService) {
            this.httpService = httpService;
            this.configService = configService;
        }
        /**
         * @param {?} user
         * @return {?}
         */
        UserServiceBase.prototype.createUser = /**
         * @param {?} user
         * @return {?}
         */
        function (user) {
            /** @type {?} */
            var headers = new http.HttpHeaders().set('Content-type', 'application/json');
            return this.httpService.post('users', user, { headers: headers });
        };
        /**
         * @param {?} username
         * @return {?}
         */
        UserServiceBase.prototype.deleteUser = /**
         * @param {?} username
         * @return {?}
         */
        function (username) {
            return this.httpService.delete('users/' + username + '');
        };
        /**
         * @param {?} username
         * @return {?}
         */
        UserServiceBase.prototype.loadUser = /**
         * @param {?} username
         * @return {?}
         */
        function (username) {
            return this.httpService.get('users/' + username + '');
        };
        /**
         * @param {?} filter
         * @return {?}
         */
        UserServiceBase.prototype.queryUsers = /**
         * @param {?} filter
         * @return {?}
         */
        function (filter) {
            /** @type {?} */
            var headers = new http.HttpHeaders().set('Content-type', 'application/json');
            return this.httpService.post('users/query', filter, { headers: headers });
        };
        /**
        *	synchronize user roles to security-service
        */
        /**
         * 	synchronize user roles to security-service
         * @param {?} filter
         * @return {?}
         */
        UserServiceBase.prototype.synchronizeRoles = /**
         * 	synchronize user roles to security-service
         * @param {?} filter
         * @return {?}
         */
        function (filter) {
            /** @type {?} */
            var headers = new http.HttpHeaders().set('Content-type', 'application/json');
            return this.httpService.post('users/admin/synchronizeRoles', filter, { headers: headers });
        };
        /**
         * @param {?} user
         * @return {?}
         */
        UserServiceBase.prototype.updateUser = /**
         * @param {?} user
         * @return {?}
         */
        function (user) {
            /** @type {?} */
            var headers = new http.HttpHeaders().set('Content-type', 'application/json');
            return this.httpService.put('users', user, { headers: headers });
        };
        UserServiceBase.decorators = [
            { type: core.Injectable }
        ];
        /** @nocollapse */
        UserServiceBase.ctorParameters = function () { return [
            { type: http.HttpClient },
            { type: chainBaseAngularClient.ConfigService }
        ]; };
        return UserServiceBase;
    }());
    if (false) {
        /** @type {?} */
        UserServiceBase.prototype.configService;
        /** @type {?} */
        UserServiceBase.prototype.httpService;
    }
    /**
     * \@generator rest2ts
     * 	javaType: inc.yukawa.chain.modules.main.rest.UsersAspectRest <br/>
     */
    var UsersService = /** @class */ (function (_super) {
        __extends(UsersService, _super);
        function UsersService(httpService, configService) {
            return _super.call(this, httpService, configService) || this;
        }
        UsersService.decorators = [
            { type: core.Injectable }
        ];
        /** @nocollapse */
        UsersService.ctorParameters = function () { return [
            { type: http.HttpClient },
            { type: chainBaseAngularClient.ConfigService }
        ]; };
        return UsersService;
    }(UserServiceBase));
    if (false) {
        /** @type {?} */
        UsersService.prototype.configService;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var UrlService = /** @class */ (function (_super) {
        __extends(UrlService, _super);
        function UrlService(configService, cfg) {
            if (cfg === void 0) { cfg = "baseUrl"; }
            return _super.call(this, cfg, configService) || this;
        }
        return UrlService;
    }(chainBaseAngularClient.UrlConfigService));

    exports.GroupsService = GroupsService;
    exports.MainModuleRest = MainModuleRest;
    exports.OrgServiceBase = OrgServiceBase;
    exports.RolesService = RolesService;
    exports.SettingsService = SettingsService;
    exports.TagService = TagService;
    exports.UrlService = UrlService;
    exports.UserServiceBase = UserServiceBase;
    exports.UsersService = UsersService;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=yukawa-chain-main-angular-core.umd.js.map
