import { HttpHeaders, HttpParams, HttpClient } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { ConfigService, UrlConfigService } from '@yukawa/chain-base-angular-client';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.modules.main.core.domain.group.Group <br/>
 * @record
 */
function Group() { }
if (false) {
    /** @type {?|undefined} */
    Group.prototype.change;
    /** @type {?|undefined} */
    Group.prototype.created;
    /** @type {?|undefined} */
    Group.prototype.info;
    /**
     * \@example users
     * @type {?}
     */
    Group.prototype.name;
    /**
     * \@example all
     * @type {?|undefined}
     */
    Group.prototype.parentId;
    /** @type {?} */
    Group.prototype.roles;
    /**
     * \@example system
     * @type {?|undefined}
     */
    Group.prototype.type;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.modules.main.core.domain.group.GroupFilter <br/>
 * @record
 */
function GroupFilter() { }
if (false) {
    /**
     * \@example ADMINS
     * @type {?|undefined}
     */
    GroupFilter.prototype.groupName;
    /**
     * \@example system
     * @type {?|undefined}
     */
    GroupFilter.prototype.type;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.modules.main.core.domain.org.Org <br/>
 * @record
 */
function Org() { }
if (false) {
    /** @type {?|undefined} */
    Org.prototype.addresses;
    /** @type {?|undefined} */
    Org.prototype.change;
    /**
     * \@example Yukawa Systems GmbH
     * @type {?|undefined}
     */
    Org.prototype.companyName;
    /** @type {?|undefined} */
    Org.prototype.created;
    /**
     * \@example yukawa\@example.com
     * @type {?|undefined}
     */
    Org.prototype.email;
    /** @type {?|undefined} */
    Org.prototype.info;
    /**
     * \@example 100
     * @type {?|undefined}
     */
    Org.prototype.orgId;
    /**
     * \@example +49 100 200 300
     * @type {?|undefined}
     */
    Org.prototype.phoneNumber;
    /**
     * \@example DE113344
     * @type {?|undefined}
     */
    Org.prototype.taxId;
    /**
     * \@example http://yukawa.de/
     * @type {?|undefined}
     */
    Org.prototype.website;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.modules.main.core.domain.org.OrgFilter <br/>
 * @record
 */
function OrgFilter() { }
if (false) {
    /** @type {?|undefined} */
    OrgFilter.prototype.addressFilter;
    /** @type {?|undefined} */
    OrgFilter.prototype.companyName;
    /** @type {?|undefined} */
    OrgFilter.prototype.email;
    /**
     * \@example 100
     * @type {?|undefined}
     */
    OrgFilter.prototype.orgId;
    /** @type {?|undefined} */
    OrgFilter.prototype.phoneNumber;
    /**
     * \@example DE113344
     * @type {?|undefined}
     */
    OrgFilter.prototype.taxId;
    /** @type {?|undefined} */
    OrgFilter.prototype.website;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.modules.main.core.domain.setting.Setting <br/>
 * @record
 */
function Setting() { }
if (false) {
    /** @type {?|undefined} */
    Setting.prototype.change;
    /**
     * \@example default central storage location
     * @type {?|undefined}
     */
    Setting.prototype.desc;
    /**
     * \@example main
     * @type {?}
     */
    Setting.prototype.module;
    /**
     * \@example Central Storage Location
     * @type {?|undefined}
     */
    Setting.prototype.name;
    /**
     * \@example storage.location.central
     * @type {?}
     */
    Setting.prototype.shortName;
    /**
     * \@example 1337
     * @type {?}
     */
    Setting.prototype.value;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.modules.main.core.domain.setting.SettingFilter <br/>
 * @record
 */
function SettingFilter() { }
if (false) {
    /**
     * \@example stock
     * @type {?|undefined}
     */
    SettingFilter.prototype.module;
    /**
     * \@example storage*
     * @type {?|undefined}
     */
    SettingFilter.prototype.shortName;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.modules.main.core.domain.tag.Tag <br/>
 * @record
 */
function Tag() { }
if (false) {
    /** @type {?|undefined} */
    Tag.prototype.change;
    /** @type {?} */
    Tag.prototype.info;
    /** @type {?|undefined} */
    Tag.prototype.key;
    /** @type {?|undefined} */
    Tag.prototype.tagId;
    /** @type {?|undefined} */
    Tag.prototype.vocabularyId;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.modules.main.core.domain.tag.TagFilter <br/>
 * @record
 */
function TagFilter() { }
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.modules.main.core.domain.user.User <br/>
 * @record
 */
function User() { }
if (false) {
    /** @type {?} */
    User.prototype.account;
    /** @type {?|undefined} */
    User.prototype.change;
    /** @type {?|undefined} */
    User.prototype.created;
    /** @type {?|undefined} */
    User.prototype.groups;
    /** @type {?|undefined} */
    User.prototype.organisationIds;
    /** @type {?|undefined} */
    User.prototype.person;
    /**
     * \@example admin
     * @type {?}
     */
    User.prototype.username;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.modules.main.core.domain.user.UserFilter <br/>
 * @record
 */
function UserFilter() { }
if (false) {
    /**
     * \@example admins
     * @type {?|undefined}
     */
    UserFilter.prototype.group;
    /** @type {?|undefined} */
    UserFilter.prototype.organisationIds;
    /** @type {?|undefined} */
    UserFilter.prototype.personFilter;
    /**
     * \@example admin
     * @type {?|undefined}
     */
    UserFilter.prototype.username;
}
/**
 * \@generator rest2ts
 * 	tag vocabulary <br/>
 * 	javaType: inc.yukawa.chain.modules.main.core.domain.tag.Vocabulary <br/>
 * @record
 */
function Vocabulary() { }
if (false) {
    /** @type {?|undefined} */
    Vocabulary.prototype.key;
    /** @type {?|undefined} */
    Vocabulary.prototype.vocabularyId;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.modules.main.rest.GroupsAspectRest <br/>
 */
class GroupsService {
    /**
     * @param {?} httpService
     * @param {?} configService
     */
    constructor(httpService, configService) {
        this.httpService = httpService;
        this.configService = configService;
    }
    /**
     * @param {?} groupName
     * @return {?}
     */
    deleteGroup(groupName) {
        return this.httpService.delete('groups/' + groupName + '');
    }
    /**
     * @param {?} group
     * @return {?}
     */
    editGroup(group) {
        /** @type {?} */
        let headers = new HttpHeaders().set('Content-type', 'application/json');
        return this.httpService.put('groups', group, { headers });
    }
    /**
     * @param {?=} pageSize
     * @param {?=} firstResult
     * @return {?}
     */
    findGroups(pageSize, firstResult) {
        /** @type {?} */
        const queryParamsList = [];
        if (pageSize !== undefined && pageSize !== null) {
            queryParamsList.push({ name: 'pageSize', value: pageSize.toString() });
        }
        if (firstResult !== undefined && firstResult !== null) {
            queryParamsList.push({ name: 'firstResult', value: firstResult.toString() });
        }
        /** @type {?} */
        let params = new HttpParams();
        for (const queryParam of queryParamsList) {
            params = params.append(queryParam.name, queryParam.value);
        }
        return this.httpService.get('groups/find', { params });
    }
    /**
     * @param {?} group
     * @return {?}
     */
    insertGroup(group) {
        /** @type {?} */
        let headers = new HttpHeaders().set('Content-type', 'application/json');
        return this.httpService.post('groups', group, { headers });
    }
    /**
     * @param {?} groupName
     * @return {?}
     */
    loadGroup(groupName) {
        return this.httpService.get('groups/' + groupName + '');
    }
    /**
     * @param {?} arg0
     * @return {?}
     */
    queryGroups(arg0) {
        /** @type {?} */
        let headers = new HttpHeaders().set('Content-type', 'application/json');
        return this.httpService.post('groups/query', arg0, { headers });
    }
}
GroupsService.decorators = [
    { type: Injectable }
];
/** @nocollapse */
GroupsService.ctorParameters = () => [
    { type: HttpClient },
    { type: ConfigService }
];
if (false) {
    /** @type {?} */
    GroupsService.prototype.configService;
    /** @type {?} */
    GroupsService.prototype.httpService;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.modules.main.rest.MainModuleRest <br/>
 */
class MainModuleRest {
    /**
     * @param {?} httpService
     * @param {?} configService
     */
    constructor(httpService, configService) {
        this.httpService = httpService;
        this.configService = configService;
    }
}
MainModuleRest.decorators = [
    { type: Injectable }
];
/** @nocollapse */
MainModuleRest.ctorParameters = () => [
    { type: HttpClient },
    { type: ConfigService }
];
if (false) {
    /** @type {?} */
    MainModuleRest.prototype.configService;
    /** @type {?} */
    MainModuleRest.prototype.httpService;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.modules.main.rest.OrgAspectRestBase <br/>
 * @template V, F
 */
class OrgServiceBase {
    /**
     * @param {?} httpService
     * @param {?} configService
     */
    constructor(httpService, configService) {
        this.httpService = httpService;
        this.configService = configService;
    }
    /**
     * @param {?} arg0
     * @return {?}
     */
    createOrg(arg0) {
        /** @type {?} */
        let headers = new HttpHeaders().set('Content-type', 'application/json');
        return this.httpService.post('orgs', arg0, { headers });
    }
    /**
     * @param {?} orgId
     * @return {?}
     */
    deleteOrg(orgId) {
        return this.httpService.delete('orgs/' + orgId + '');
    }
    /**
     * @param {?} orgId
     * @return {?}
     */
    loadOrg(orgId) {
        return this.httpService.get('orgs/' + orgId + '');
    }
    /**
     * @param {?} filter
     * @return {?}
     */
    queryOrgs(filter) {
        /** @type {?} */
        let headers = new HttpHeaders().set('Content-type', 'application/json');
        return this.httpService.post('orgs/query', filter, { headers });
    }
    /**
     * @param {?} arg0
     * @return {?}
     */
    updateOrg(arg0) {
        /** @type {?} */
        let headers = new HttpHeaders().set('Content-type', 'application/json');
        return this.httpService.put('orgs', arg0, { headers });
    }
}
OrgServiceBase.decorators = [
    { type: Injectable }
];
/** @nocollapse */
OrgServiceBase.ctorParameters = () => [
    { type: HttpClient },
    { type: ConfigService }
];
if (false) {
    /** @type {?} */
    OrgServiceBase.prototype.configService;
    /** @type {?} */
    OrgServiceBase.prototype.httpService;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.modules.main.rest.RolesAspectRest <br/>
 */
class RolesService {
    /**
     * @param {?} httpService
     * @param {?} configService
     */
    constructor(httpService, configService) {
        this.httpService = httpService;
        this.configService = configService;
    }
    /**
     * @param {?} filter
     * @return {?}
     */
    findRoles(filter) {
        /** @type {?} */
        let headers = new HttpHeaders().set('Content-type', 'application/json');
        return this.httpService.post('/roles/find', filter, { headers });
    }
    /**
     * @return {?}
     */
    getAllRoles() {
        return this.httpService.get('/roles/all');
    }
    /**
     * @param {?} roleName
     * @return {?}
     */
    loadRole(roleName) {
        return this.httpService.get('/roles/' + roleName + '');
    }
    /**
     * @param {?} filter
     * @return {?}
     */
    queryRoles(filter) {
        /** @type {?} */
        let headers = new HttpHeaders().set('Content-type', 'application/json');
        return this.httpService.post('/roles/query', filter, { headers });
    }
}
RolesService.decorators = [
    { type: Injectable }
];
/** @nocollapse */
RolesService.ctorParameters = () => [
    { type: HttpClient },
    { type: ConfigService }
];
if (false) {
    /** @type {?} */
    RolesService.prototype.configService;
    /** @type {?} */
    RolesService.prototype.httpService;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.modules.main.rest.SettingsAspectRest <br/>
 */
class SettingsService {
    /**
     * @param {?} httpService
     * @param {?} configService
     */
    constructor(httpService, configService) {
        this.httpService = httpService;
        this.configService = configService;
    }
    /**
     * @param {?} module
     * @param {?} shortName
     * @return {?}
     */
    deleteSetting(module, shortName) {
        return this.httpService.delete('settings/' + module + '/' + shortName + '');
    }
    /**
     * @param {?} setting
     * @return {?}
     */
    editSetting(setting) {
        /** @type {?} */
        let headers = new HttpHeaders().set('Content-type', 'application/json');
        return this.httpService.put('settings', setting, { headers });
    }
    /**
     * 	find settings
     * @param {?=} module
     * @param {?=} shortName
     * @param {?=} keyword
     * @param {?=} pageSize
     * @param {?=} firstResult
     * @return {?}
     */
    findSettings(module, shortName, keyword, pageSize, firstResult) {
        /** @type {?} */
        const queryParamsList = [];
        if (module !== undefined && module !== null) {
            queryParamsList.push({ name: 'module', value: module });
        }
        if (shortName !== undefined && shortName !== null) {
            queryParamsList.push({ name: 'shortName', value: shortName });
        }
        if (keyword !== undefined && keyword !== null) {
            queryParamsList.push({ name: 'keyword', value: keyword });
        }
        if (pageSize !== undefined && pageSize !== null) {
            queryParamsList.push({ name: 'pageSize', value: pageSize.toString() });
        }
        if (firstResult !== undefined && firstResult !== null) {
            queryParamsList.push({ name: 'firstResult', value: firstResult.toString() });
        }
        /** @type {?} */
        let params = new HttpParams();
        for (const queryParam of queryParamsList) {
            params = params.append(queryParam.name, queryParam.value);
        }
        return this.httpService.get('settings', { params });
    }
    /**
     * @return {?}
     */
    getMeta() {
        return this.httpService.get('settings/admin/meta');
    }
    /**
     * @return {?}
     */
    loadMapping() {
        return this.httpService.get('settings/admin/index');
    }
    /**
     * @param {?} module
     * @param {?} shortName
     * @return {?}
     */
    loadSetting(module, shortName) {
        return this.httpService.get('settings/' + module + '/' + shortName + '');
    }
    /**
     * @param {?=} input
     * @return {?}
     */
    ping(input) {
        /** @type {?} */
        const queryParamsList = [];
        if (input !== undefined && input !== null) {
            queryParamsList.push({ name: 'input', value: input.toString() });
        }
        /** @type {?} */
        let params = new HttpParams();
        for (const queryParam of queryParamsList) {
            params = params.append(queryParam.name, queryParam.value);
        }
        return this.httpService.get('settings/ping', { params });
    }
    /**
     * @param {?} filter
     * @return {?}
     */
    querySettings(filter) {
        /** @type {?} */
        let headers = new HttpHeaders().set('Content-type', 'application/json');
        return this.httpService.post('settings/query', filter, { headers });
    }
}
SettingsService.decorators = [
    { type: Injectable }
];
/** @nocollapse */
SettingsService.ctorParameters = () => [
    { type: HttpClient },
    { type: ConfigService }
];
if (false) {
    /** @type {?} */
    SettingsService.prototype.configService;
    /** @type {?} */
    SettingsService.prototype.httpService;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.modules.main.rest.TagAspectRest <br/>
 */
class TagService {
    /**
     * @param {?} httpService
     * @param {?} configService
     */
    constructor(httpService, configService) {
        this.httpService = httpService;
        this.configService = configService;
    }
    /**
     * @param {?=} arg0
     * @return {?}
     */
    ping(arg0) {
        /** @type {?} */
        const queryParamsList = [];
        if (arg0 !== undefined && arg0 !== null) {
            queryParamsList.push({ name: 'arg0', value: arg0.toString() });
        }
        /** @type {?} */
        let params = new HttpParams();
        for (const queryParam of queryParamsList) {
            params = params.append(queryParam.name, queryParam.value);
        }
        return this.httpService.get('tags/ping', { params });
    }
    /**
     * @param {?} arg0
     * @return {?}
     */
    queryTags(arg0) {
        /** @type {?} */
        let headers = new HttpHeaders().set('Content-type', 'application/json');
        return this.httpService.post('tags/query', arg0, { headers });
    }
}
TagService.decorators = [
    { type: Injectable }
];
/** @nocollapse */
TagService.ctorParameters = () => [
    { type: HttpClient },
    { type: ConfigService }
];
if (false) {
    /** @type {?} */
    TagService.prototype.configService;
    /** @type {?} */
    TagService.prototype.httpService;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.modules.main.rest.UserAspectRestBase <br/>
 * @template V, F
 */
class UserServiceBase {
    /**
     * @param {?} httpService
     * @param {?} configService
     */
    constructor(httpService, configService) {
        this.httpService = httpService;
        this.configService = configService;
    }
    /**
     * @param {?} user
     * @return {?}
     */
    createUser(user) {
        /** @type {?} */
        let headers = new HttpHeaders().set('Content-type', 'application/json');
        return this.httpService.post('users', user, { headers });
    }
    /**
     * @param {?} username
     * @return {?}
     */
    deleteUser(username) {
        return this.httpService.delete('users/' + username + '');
    }
    /**
     * @param {?} username
     * @return {?}
     */
    loadUser(username) {
        return this.httpService.get('users/' + username + '');
    }
    /**
     * @param {?} filter
     * @return {?}
     */
    queryUsers(filter) {
        /** @type {?} */
        let headers = new HttpHeaders().set('Content-type', 'application/json');
        return this.httpService.post('users/query', filter, { headers });
    }
    /**
     * 	synchronize user roles to security-service
     * @param {?} filter
     * @return {?}
     */
    synchronizeRoles(filter) {
        /** @type {?} */
        let headers = new HttpHeaders().set('Content-type', 'application/json');
        return this.httpService.post('users/admin/synchronizeRoles', filter, { headers });
    }
    /**
     * @param {?} user
     * @return {?}
     */
    updateUser(user) {
        /** @type {?} */
        let headers = new HttpHeaders().set('Content-type', 'application/json');
        return this.httpService.put('users', user, { headers });
    }
}
UserServiceBase.decorators = [
    { type: Injectable }
];
/** @nocollapse */
UserServiceBase.ctorParameters = () => [
    { type: HttpClient },
    { type: ConfigService }
];
if (false) {
    /** @type {?} */
    UserServiceBase.prototype.configService;
    /** @type {?} */
    UserServiceBase.prototype.httpService;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.modules.main.rest.UsersAspectRest <br/>
 */
class UsersService extends UserServiceBase {
    /**
     * @param {?} httpService
     * @param {?} configService
     */
    constructor(httpService, configService) {
        super(httpService, configService);
    }
}
UsersService.decorators = [
    { type: Injectable }
];
/** @nocollapse */
UsersService.ctorParameters = () => [
    { type: HttpClient },
    { type: ConfigService }
];
if (false) {
    /** @type {?} */
    UsersService.prototype.configService;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class UrlService extends UrlConfigService {
    /**
     * @param {?} configService
     * @param {?=} cfg
     */
    constructor(configService, cfg = "baseUrl") {
        super(cfg, configService);
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { GroupsService, MainModuleRest, OrgServiceBase, RolesService, SettingsService, TagService, UrlService, UserServiceBase, UsersService };
//# sourceMappingURL=yukawa-chain-main-angular-core.js.map
