import { __values, __extends } from 'tslib';
import { HttpHeaders, HttpParams, HttpClient } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { ConfigService, UrlConfigService } from '@yukawa/chain-base-angular-client';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.modules.main.core.domain.group.Group <br/>
 * @record
 */
function Group() { }
if (false) {
    /** @type {?|undefined} */
    Group.prototype.change;
    /** @type {?|undefined} */
    Group.prototype.created;
    /** @type {?|undefined} */
    Group.prototype.info;
    /**
     * \@example users
     * @type {?}
     */
    Group.prototype.name;
    /**
     * \@example all
     * @type {?|undefined}
     */
    Group.prototype.parentId;
    /** @type {?} */
    Group.prototype.roles;
    /**
     * \@example system
     * @type {?|undefined}
     */
    Group.prototype.type;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.modules.main.core.domain.group.GroupFilter <br/>
 * @record
 */
function GroupFilter() { }
if (false) {
    /**
     * \@example ADMINS
     * @type {?|undefined}
     */
    GroupFilter.prototype.groupName;
    /**
     * \@example system
     * @type {?|undefined}
     */
    GroupFilter.prototype.type;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.modules.main.core.domain.org.Org <br/>
 * @record
 */
function Org() { }
if (false) {
    /** @type {?|undefined} */
    Org.prototype.addresses;
    /** @type {?|undefined} */
    Org.prototype.change;
    /**
     * \@example Yukawa Systems GmbH
     * @type {?|undefined}
     */
    Org.prototype.companyName;
    /** @type {?|undefined} */
    Org.prototype.created;
    /**
     * \@example yukawa\@example.com
     * @type {?|undefined}
     */
    Org.prototype.email;
    /** @type {?|undefined} */
    Org.prototype.info;
    /**
     * \@example 100
     * @type {?|undefined}
     */
    Org.prototype.orgId;
    /**
     * \@example +49 100 200 300
     * @type {?|undefined}
     */
    Org.prototype.phoneNumber;
    /**
     * \@example DE113344
     * @type {?|undefined}
     */
    Org.prototype.taxId;
    /**
     * \@example http://yukawa.de/
     * @type {?|undefined}
     */
    Org.prototype.website;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.modules.main.core.domain.org.OrgFilter <br/>
 * @record
 */
function OrgFilter() { }
if (false) {
    /** @type {?|undefined} */
    OrgFilter.prototype.addressFilter;
    /** @type {?|undefined} */
    OrgFilter.prototype.companyName;
    /** @type {?|undefined} */
    OrgFilter.prototype.email;
    /**
     * \@example 100
     * @type {?|undefined}
     */
    OrgFilter.prototype.orgId;
    /** @type {?|undefined} */
    OrgFilter.prototype.phoneNumber;
    /**
     * \@example DE113344
     * @type {?|undefined}
     */
    OrgFilter.prototype.taxId;
    /** @type {?|undefined} */
    OrgFilter.prototype.website;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.modules.main.core.domain.setting.Setting <br/>
 * @record
 */
function Setting() { }
if (false) {
    /** @type {?|undefined} */
    Setting.prototype.change;
    /**
     * \@example default central storage location
     * @type {?|undefined}
     */
    Setting.prototype.desc;
    /**
     * \@example main
     * @type {?}
     */
    Setting.prototype.module;
    /**
     * \@example Central Storage Location
     * @type {?|undefined}
     */
    Setting.prototype.name;
    /**
     * \@example storage.location.central
     * @type {?}
     */
    Setting.prototype.shortName;
    /**
     * \@example 1337
     * @type {?}
     */
    Setting.prototype.value;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.modules.main.core.domain.setting.SettingFilter <br/>
 * @record
 */
function SettingFilter() { }
if (false) {
    /**
     * \@example stock
     * @type {?|undefined}
     */
    SettingFilter.prototype.module;
    /**
     * \@example storage*
     * @type {?|undefined}
     */
    SettingFilter.prototype.shortName;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.modules.main.core.domain.tag.Tag <br/>
 * @record
 */
function Tag() { }
if (false) {
    /** @type {?|undefined} */
    Tag.prototype.change;
    /** @type {?} */
    Tag.prototype.info;
    /** @type {?|undefined} */
    Tag.prototype.key;
    /** @type {?|undefined} */
    Tag.prototype.tagId;
    /** @type {?|undefined} */
    Tag.prototype.vocabularyId;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.modules.main.core.domain.tag.TagFilter <br/>
 * @record
 */
function TagFilter() { }
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.modules.main.core.domain.user.User <br/>
 * @record
 */
function User() { }
if (false) {
    /** @type {?} */
    User.prototype.account;
    /** @type {?|undefined} */
    User.prototype.change;
    /** @type {?|undefined} */
    User.prototype.created;
    /** @type {?|undefined} */
    User.prototype.groups;
    /** @type {?|undefined} */
    User.prototype.organisationIds;
    /** @type {?|undefined} */
    User.prototype.person;
    /**
     * \@example admin
     * @type {?}
     */
    User.prototype.username;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.modules.main.core.domain.user.UserFilter <br/>
 * @record
 */
function UserFilter() { }
if (false) {
    /**
     * \@example admins
     * @type {?|undefined}
     */
    UserFilter.prototype.group;
    /** @type {?|undefined} */
    UserFilter.prototype.organisationIds;
    /** @type {?|undefined} */
    UserFilter.prototype.personFilter;
    /**
     * \@example admin
     * @type {?|undefined}
     */
    UserFilter.prototype.username;
}
/**
 * \@generator rest2ts
 * 	tag vocabulary <br/>
 * 	javaType: inc.yukawa.chain.modules.main.core.domain.tag.Vocabulary <br/>
 * @record
 */
function Vocabulary() { }
if (false) {
    /** @type {?|undefined} */
    Vocabulary.prototype.key;
    /** @type {?|undefined} */
    Vocabulary.prototype.vocabularyId;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.modules.main.rest.GroupsAspectRest <br/>
 */
var GroupsService = /** @class */ (function () {
    function GroupsService(httpService, configService) {
        this.httpService = httpService;
        this.configService = configService;
    }
    /**
     * @param {?} groupName
     * @return {?}
     */
    GroupsService.prototype.deleteGroup = /**
     * @param {?} groupName
     * @return {?}
     */
    function (groupName) {
        return this.httpService.delete('groups/' + groupName + '');
    };
    /**
     * @param {?} group
     * @return {?}
     */
    GroupsService.prototype.editGroup = /**
     * @param {?} group
     * @return {?}
     */
    function (group) {
        /** @type {?} */
        var headers = new HttpHeaders().set('Content-type', 'application/json');
        return this.httpService.put('groups', group, { headers: headers });
    };
    /**
     * @param {?=} pageSize
     * @param {?=} firstResult
     * @return {?}
     */
    GroupsService.prototype.findGroups = /**
     * @param {?=} pageSize
     * @param {?=} firstResult
     * @return {?}
     */
    function (pageSize, firstResult) {
        var e_1, _a;
        /** @type {?} */
        var queryParamsList = [];
        if (pageSize !== undefined && pageSize !== null) {
            queryParamsList.push({ name: 'pageSize', value: pageSize.toString() });
        }
        if (firstResult !== undefined && firstResult !== null) {
            queryParamsList.push({ name: 'firstResult', value: firstResult.toString() });
        }
        /** @type {?} */
        var params = new HttpParams();
        try {
            for (var queryParamsList_1 = __values(queryParamsList), queryParamsList_1_1 = queryParamsList_1.next(); !queryParamsList_1_1.done; queryParamsList_1_1 = queryParamsList_1.next()) {
                var queryParam = queryParamsList_1_1.value;
                params = params.append(queryParam.name, queryParam.value);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (queryParamsList_1_1 && !queryParamsList_1_1.done && (_a = queryParamsList_1.return)) _a.call(queryParamsList_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return this.httpService.get('groups/find', { params: params });
    };
    /**
     * @param {?} group
     * @return {?}
     */
    GroupsService.prototype.insertGroup = /**
     * @param {?} group
     * @return {?}
     */
    function (group) {
        /** @type {?} */
        var headers = new HttpHeaders().set('Content-type', 'application/json');
        return this.httpService.post('groups', group, { headers: headers });
    };
    /**
     * @param {?} groupName
     * @return {?}
     */
    GroupsService.prototype.loadGroup = /**
     * @param {?} groupName
     * @return {?}
     */
    function (groupName) {
        return this.httpService.get('groups/' + groupName + '');
    };
    /**
     * @param {?} arg0
     * @return {?}
     */
    GroupsService.prototype.queryGroups = /**
     * @param {?} arg0
     * @return {?}
     */
    function (arg0) {
        /** @type {?} */
        var headers = new HttpHeaders().set('Content-type', 'application/json');
        return this.httpService.post('groups/query', arg0, { headers: headers });
    };
    GroupsService.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    GroupsService.ctorParameters = function () { return [
        { type: HttpClient },
        { type: ConfigService }
    ]; };
    return GroupsService;
}());
if (false) {
    /** @type {?} */
    GroupsService.prototype.configService;
    /** @type {?} */
    GroupsService.prototype.httpService;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.modules.main.rest.MainModuleRest <br/>
 */
var MainModuleRest = /** @class */ (function () {
    function MainModuleRest(httpService, configService) {
        this.httpService = httpService;
        this.configService = configService;
    }
    MainModuleRest.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    MainModuleRest.ctorParameters = function () { return [
        { type: HttpClient },
        { type: ConfigService }
    ]; };
    return MainModuleRest;
}());
if (false) {
    /** @type {?} */
    MainModuleRest.prototype.configService;
    /** @type {?} */
    MainModuleRest.prototype.httpService;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.modules.main.rest.OrgAspectRestBase <br/>
 * @template V, F
 */
var OrgServiceBase = /** @class */ (function () {
    function OrgServiceBase(httpService, configService) {
        this.httpService = httpService;
        this.configService = configService;
    }
    /**
     * @param {?} arg0
     * @return {?}
     */
    OrgServiceBase.prototype.createOrg = /**
     * @param {?} arg0
     * @return {?}
     */
    function (arg0) {
        /** @type {?} */
        var headers = new HttpHeaders().set('Content-type', 'application/json');
        return this.httpService.post('orgs', arg0, { headers: headers });
    };
    /**
     * @param {?} orgId
     * @return {?}
     */
    OrgServiceBase.prototype.deleteOrg = /**
     * @param {?} orgId
     * @return {?}
     */
    function (orgId) {
        return this.httpService.delete('orgs/' + orgId + '');
    };
    /**
     * @param {?} orgId
     * @return {?}
     */
    OrgServiceBase.prototype.loadOrg = /**
     * @param {?} orgId
     * @return {?}
     */
    function (orgId) {
        return this.httpService.get('orgs/' + orgId + '');
    };
    /**
     * @param {?} filter
     * @return {?}
     */
    OrgServiceBase.prototype.queryOrgs = /**
     * @param {?} filter
     * @return {?}
     */
    function (filter) {
        /** @type {?} */
        var headers = new HttpHeaders().set('Content-type', 'application/json');
        return this.httpService.post('orgs/query', filter, { headers: headers });
    };
    /**
     * @param {?} arg0
     * @return {?}
     */
    OrgServiceBase.prototype.updateOrg = /**
     * @param {?} arg0
     * @return {?}
     */
    function (arg0) {
        /** @type {?} */
        var headers = new HttpHeaders().set('Content-type', 'application/json');
        return this.httpService.put('orgs', arg0, { headers: headers });
    };
    OrgServiceBase.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    OrgServiceBase.ctorParameters = function () { return [
        { type: HttpClient },
        { type: ConfigService }
    ]; };
    return OrgServiceBase;
}());
if (false) {
    /** @type {?} */
    OrgServiceBase.prototype.configService;
    /** @type {?} */
    OrgServiceBase.prototype.httpService;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.modules.main.rest.RolesAspectRest <br/>
 */
var RolesService = /** @class */ (function () {
    function RolesService(httpService, configService) {
        this.httpService = httpService;
        this.configService = configService;
    }
    /**
     * @param {?} filter
     * @return {?}
     */
    RolesService.prototype.findRoles = /**
     * @param {?} filter
     * @return {?}
     */
    function (filter) {
        /** @type {?} */
        var headers = new HttpHeaders().set('Content-type', 'application/json');
        return this.httpService.post('/roles/find', filter, { headers: headers });
    };
    /**
     * @return {?}
     */
    RolesService.prototype.getAllRoles = /**
     * @return {?}
     */
    function () {
        return this.httpService.get('/roles/all');
    };
    /**
     * @param {?} roleName
     * @return {?}
     */
    RolesService.prototype.loadRole = /**
     * @param {?} roleName
     * @return {?}
     */
    function (roleName) {
        return this.httpService.get('/roles/' + roleName + '');
    };
    /**
     * @param {?} filter
     * @return {?}
     */
    RolesService.prototype.queryRoles = /**
     * @param {?} filter
     * @return {?}
     */
    function (filter) {
        /** @type {?} */
        var headers = new HttpHeaders().set('Content-type', 'application/json');
        return this.httpService.post('/roles/query', filter, { headers: headers });
    };
    RolesService.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    RolesService.ctorParameters = function () { return [
        { type: HttpClient },
        { type: ConfigService }
    ]; };
    return RolesService;
}());
if (false) {
    /** @type {?} */
    RolesService.prototype.configService;
    /** @type {?} */
    RolesService.prototype.httpService;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.modules.main.rest.SettingsAspectRest <br/>
 */
var SettingsService = /** @class */ (function () {
    function SettingsService(httpService, configService) {
        this.httpService = httpService;
        this.configService = configService;
    }
    /**
     * @param {?} module
     * @param {?} shortName
     * @return {?}
     */
    SettingsService.prototype.deleteSetting = /**
     * @param {?} module
     * @param {?} shortName
     * @return {?}
     */
    function (module, shortName) {
        return this.httpService.delete('settings/' + module + '/' + shortName + '');
    };
    /**
     * @param {?} setting
     * @return {?}
     */
    SettingsService.prototype.editSetting = /**
     * @param {?} setting
     * @return {?}
     */
    function (setting) {
        /** @type {?} */
        var headers = new HttpHeaders().set('Content-type', 'application/json');
        return this.httpService.put('settings', setting, { headers: headers });
    };
    /**
    *	find settings
    */
    /**
     * 	find settings
     * @param {?=} module
     * @param {?=} shortName
     * @param {?=} keyword
     * @param {?=} pageSize
     * @param {?=} firstResult
     * @return {?}
     */
    SettingsService.prototype.findSettings = /**
     * 	find settings
     * @param {?=} module
     * @param {?=} shortName
     * @param {?=} keyword
     * @param {?=} pageSize
     * @param {?=} firstResult
     * @return {?}
     */
    function (module, shortName, keyword, pageSize, firstResult) {
        var e_2, _a;
        /** @type {?} */
        var queryParamsList = [];
        if (module !== undefined && module !== null) {
            queryParamsList.push({ name: 'module', value: module });
        }
        if (shortName !== undefined && shortName !== null) {
            queryParamsList.push({ name: 'shortName', value: shortName });
        }
        if (keyword !== undefined && keyword !== null) {
            queryParamsList.push({ name: 'keyword', value: keyword });
        }
        if (pageSize !== undefined && pageSize !== null) {
            queryParamsList.push({ name: 'pageSize', value: pageSize.toString() });
        }
        if (firstResult !== undefined && firstResult !== null) {
            queryParamsList.push({ name: 'firstResult', value: firstResult.toString() });
        }
        /** @type {?} */
        var params = new HttpParams();
        try {
            for (var queryParamsList_2 = __values(queryParamsList), queryParamsList_2_1 = queryParamsList_2.next(); !queryParamsList_2_1.done; queryParamsList_2_1 = queryParamsList_2.next()) {
                var queryParam = queryParamsList_2_1.value;
                params = params.append(queryParam.name, queryParam.value);
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (queryParamsList_2_1 && !queryParamsList_2_1.done && (_a = queryParamsList_2.return)) _a.call(queryParamsList_2);
            }
            finally { if (e_2) throw e_2.error; }
        }
        return this.httpService.get('settings', { params: params });
    };
    /**
     * @return {?}
     */
    SettingsService.prototype.getMeta = /**
     * @return {?}
     */
    function () {
        return this.httpService.get('settings/admin/meta');
    };
    /**
     * @return {?}
     */
    SettingsService.prototype.loadMapping = /**
     * @return {?}
     */
    function () {
        return this.httpService.get('settings/admin/index');
    };
    /**
     * @param {?} module
     * @param {?} shortName
     * @return {?}
     */
    SettingsService.prototype.loadSetting = /**
     * @param {?} module
     * @param {?} shortName
     * @return {?}
     */
    function (module, shortName) {
        return this.httpService.get('settings/' + module + '/' + shortName + '');
    };
    /**
     * @param {?=} input
     * @return {?}
     */
    SettingsService.prototype.ping = /**
     * @param {?=} input
     * @return {?}
     */
    function (input) {
        var e_3, _a;
        /** @type {?} */
        var queryParamsList = [];
        if (input !== undefined && input !== null) {
            queryParamsList.push({ name: 'input', value: input.toString() });
        }
        /** @type {?} */
        var params = new HttpParams();
        try {
            for (var queryParamsList_3 = __values(queryParamsList), queryParamsList_3_1 = queryParamsList_3.next(); !queryParamsList_3_1.done; queryParamsList_3_1 = queryParamsList_3.next()) {
                var queryParam = queryParamsList_3_1.value;
                params = params.append(queryParam.name, queryParam.value);
            }
        }
        catch (e_3_1) { e_3 = { error: e_3_1 }; }
        finally {
            try {
                if (queryParamsList_3_1 && !queryParamsList_3_1.done && (_a = queryParamsList_3.return)) _a.call(queryParamsList_3);
            }
            finally { if (e_3) throw e_3.error; }
        }
        return this.httpService.get('settings/ping', { params: params });
    };
    /**
     * @param {?} filter
     * @return {?}
     */
    SettingsService.prototype.querySettings = /**
     * @param {?} filter
     * @return {?}
     */
    function (filter) {
        /** @type {?} */
        var headers = new HttpHeaders().set('Content-type', 'application/json');
        return this.httpService.post('settings/query', filter, { headers: headers });
    };
    SettingsService.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    SettingsService.ctorParameters = function () { return [
        { type: HttpClient },
        { type: ConfigService }
    ]; };
    return SettingsService;
}());
if (false) {
    /** @type {?} */
    SettingsService.prototype.configService;
    /** @type {?} */
    SettingsService.prototype.httpService;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.modules.main.rest.TagAspectRest <br/>
 */
var TagService = /** @class */ (function () {
    function TagService(httpService, configService) {
        this.httpService = httpService;
        this.configService = configService;
    }
    /**
     * @param {?=} arg0
     * @return {?}
     */
    TagService.prototype.ping = /**
     * @param {?=} arg0
     * @return {?}
     */
    function (arg0) {
        var e_4, _a;
        /** @type {?} */
        var queryParamsList = [];
        if (arg0 !== undefined && arg0 !== null) {
            queryParamsList.push({ name: 'arg0', value: arg0.toString() });
        }
        /** @type {?} */
        var params = new HttpParams();
        try {
            for (var queryParamsList_4 = __values(queryParamsList), queryParamsList_4_1 = queryParamsList_4.next(); !queryParamsList_4_1.done; queryParamsList_4_1 = queryParamsList_4.next()) {
                var queryParam = queryParamsList_4_1.value;
                params = params.append(queryParam.name, queryParam.value);
            }
        }
        catch (e_4_1) { e_4 = { error: e_4_1 }; }
        finally {
            try {
                if (queryParamsList_4_1 && !queryParamsList_4_1.done && (_a = queryParamsList_4.return)) _a.call(queryParamsList_4);
            }
            finally { if (e_4) throw e_4.error; }
        }
        return this.httpService.get('tags/ping', { params: params });
    };
    /**
     * @param {?} arg0
     * @return {?}
     */
    TagService.prototype.queryTags = /**
     * @param {?} arg0
     * @return {?}
     */
    function (arg0) {
        /** @type {?} */
        var headers = new HttpHeaders().set('Content-type', 'application/json');
        return this.httpService.post('tags/query', arg0, { headers: headers });
    };
    TagService.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    TagService.ctorParameters = function () { return [
        { type: HttpClient },
        { type: ConfigService }
    ]; };
    return TagService;
}());
if (false) {
    /** @type {?} */
    TagService.prototype.configService;
    /** @type {?} */
    TagService.prototype.httpService;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.modules.main.rest.UserAspectRestBase <br/>
 * @template V, F
 */
var UserServiceBase = /** @class */ (function () {
    function UserServiceBase(httpService, configService) {
        this.httpService = httpService;
        this.configService = configService;
    }
    /**
     * @param {?} user
     * @return {?}
     */
    UserServiceBase.prototype.createUser = /**
     * @param {?} user
     * @return {?}
     */
    function (user) {
        /** @type {?} */
        var headers = new HttpHeaders().set('Content-type', 'application/json');
        return this.httpService.post('users', user, { headers: headers });
    };
    /**
     * @param {?} username
     * @return {?}
     */
    UserServiceBase.prototype.deleteUser = /**
     * @param {?} username
     * @return {?}
     */
    function (username) {
        return this.httpService.delete('users/' + username + '');
    };
    /**
     * @param {?} username
     * @return {?}
     */
    UserServiceBase.prototype.loadUser = /**
     * @param {?} username
     * @return {?}
     */
    function (username) {
        return this.httpService.get('users/' + username + '');
    };
    /**
     * @param {?} filter
     * @return {?}
     */
    UserServiceBase.prototype.queryUsers = /**
     * @param {?} filter
     * @return {?}
     */
    function (filter) {
        /** @type {?} */
        var headers = new HttpHeaders().set('Content-type', 'application/json');
        return this.httpService.post('users/query', filter, { headers: headers });
    };
    /**
    *	synchronize user roles to security-service
    */
    /**
     * 	synchronize user roles to security-service
     * @param {?} filter
     * @return {?}
     */
    UserServiceBase.prototype.synchronizeRoles = /**
     * 	synchronize user roles to security-service
     * @param {?} filter
     * @return {?}
     */
    function (filter) {
        /** @type {?} */
        var headers = new HttpHeaders().set('Content-type', 'application/json');
        return this.httpService.post('users/admin/synchronizeRoles', filter, { headers: headers });
    };
    /**
     * @param {?} user
     * @return {?}
     */
    UserServiceBase.prototype.updateUser = /**
     * @param {?} user
     * @return {?}
     */
    function (user) {
        /** @type {?} */
        var headers = new HttpHeaders().set('Content-type', 'application/json');
        return this.httpService.put('users', user, { headers: headers });
    };
    UserServiceBase.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    UserServiceBase.ctorParameters = function () { return [
        { type: HttpClient },
        { type: ConfigService }
    ]; };
    return UserServiceBase;
}());
if (false) {
    /** @type {?} */
    UserServiceBase.prototype.configService;
    /** @type {?} */
    UserServiceBase.prototype.httpService;
}
/**
 * \@generator rest2ts
 * 	javaType: inc.yukawa.chain.modules.main.rest.UsersAspectRest <br/>
 */
var UsersService = /** @class */ (function (_super) {
    __extends(UsersService, _super);
    function UsersService(httpService, configService) {
        return _super.call(this, httpService, configService) || this;
    }
    UsersService.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    UsersService.ctorParameters = function () { return [
        { type: HttpClient },
        { type: ConfigService }
    ]; };
    return UsersService;
}(UserServiceBase));
if (false) {
    /** @type {?} */
    UsersService.prototype.configService;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var UrlService = /** @class */ (function (_super) {
    __extends(UrlService, _super);
    function UrlService(configService, cfg) {
        if (cfg === void 0) { cfg = "baseUrl"; }
        return _super.call(this, cfg, configService) || this;
    }
    return UrlService;
}(UrlConfigService));

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { GroupsService, MainModuleRest, OrgServiceBase, RolesService, SettingsService, TagService, UrlService, UserServiceBase, UsersService };
//# sourceMappingURL=yukawa-chain-main-angular-core.js.map
